/*
Copyright (C) 2006 Samuel Gravan Perez (samiloes@yahoo.es)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <iostream>
#include <string>
#include <sstream>
#include "ServidorSAM.h"
#include "Parse.h"

using namespace std;

list<Cliente> ServidorSAM::clientes=list<Cliente>();
list<Canal> ServidorSAM::canales=list<Canal>();
list<string> ServidorSAM::baneados=list<string>();
hash_map<string,ServidorSAM*,stringhasher> ServidorSAM::clt_socket=hash_map<string,ServidorSAM*,stringhasher>();
hash_map<string,int,stringhasher> ServidorSAM::ips=hash_map<string,int,stringhasher>();
int ServidorSAM::puerto=6667;
string ServidorSAM::estado="";
string ServidorSAM::pass="";
string ServidorSAM::ipEscucha="";

ServidorSAM::ServidorSAM(ISocketHandler& h)
:TcpSocket(h),IEventOwner(static_cast<MyEventHandler&>(h))
{
	SetLineProtocol();
	c.canal=ServidorSAM::canales.end();
	static_cast<MyEventHandler&>(Handler()).AddEvent(this,180,0);
}


ServidorSAM::~ServidorSAM()
{
	static_cast<MyEventHandler&>(Handler()).ClearEvents(this);
	this->SetFlushBeforeClose();
	this->Close();
}

void ServidorSAM::OnEvent(int id)
{
	if(c.act>150)
	{
		list<Canal>::iterator c1;
		list<Cliente>::iterator u1;
		
		c1=c.canal;
		for(u1=c1->usuarios.begin();u1!=c1->usuarios.end();u1++)
        	{
           		hash_map<string,ServidorSAM*,stringhasher>::iterator m1;
            		m1=ServidorSAM::clt_socket.find(u1->nick);
            		if(m1!=ServidorSAM::clt_socket.end())
				m1->second->Send("276:" + c.nick);
        	}
		ServidorSAM::baneados.push_back(c.ip);
        	Send("955:Demasiada actividad!!");
        	SetCloseAndDelete();					
	}
	else
	{
		if(c.ping==true)
		{
            		Send("955:Desconectado por falta de respuesta");						
			SetCloseAndDelete();
		}
		else
		if(c.act==0)
		{			                                              			
			c.ping=true;
           		Send("285");			
		}
		c.act=0;
		static_cast<MyEventHandler&>(Handler()).AddEvent(this,180,0);		
	}
}

void ServidorSAM::OnDelete(void)
{
        if(c.nick.length()>0)
        {               
                list<Cliente>::iterator r;
		list<Canal>::iterator c1;
		hash_map<string,int,stringhasher>::iterator ip=ServidorSAM::ips.find(c.ip);
		
		if(ip!=ServidorSAM::ips.end())
			ip->second--;

		r=find(ServidorSAM::clientes.begin(),ServidorSAM::clientes.end(),c.nick);
		c1=c.canal;
	        ServidorSAM::clientes.erase(r);

		if(c1!=ServidorSAM::canales.end())
		{
                	for(r=c1->usuarios.begin();r!=c1->usuarios.end();r++)
                	{
                        	hash_map<string,ServidorSAM*,stringhasher>::iterator m1;
                       		m1=ServidorSAM::clt_socket.find(r->nick);
        	                if(m1!=ServidorSAM::clt_socket.end())
								m1->second->Send("273:" + c.nick);
	                }
			r=find(c1->usuarios.begin(),c1->usuarios.end(),c.nick);
			c1->usuarios.erase(r);
			if(c1->usuarios.size()==0)
					ServidorSAM::canales.erase(c1);											    
		}
        }
        
	hash_map<string,ServidorSAM*,stringhasher>::iterator it=ServidorSAM::clt_socket.find(c.nick);
	if(it!=ServidorSAM::clt_socket.end())		
		ServidorSAM::clt_socket.erase(it);
	static_cast<MyEventHandler&>(Handler()).ClearEvents(this);
}

void ServidorSAM::OnException(void)
{
	OnDelete();
}

void ServidorSAM::OnConnectFailed(void)
{
     	OnDelete();
}

void ServidorSAM::OnLine(const std::string& cmd)
{
	string a,nick;
	Parse par(cmd);

	par.setbreak(':');
	a=par.getword();	
   
	c.act++;
	if(a=="100")
	{
		par.getword();
		nick=par.getword();

		if(ServidorSAM::clt_socket.size()>=MAX_USUARIOS)
		{
			Send("125");
			SetCloseAndDelete();
			return;
		}

		string ra=GetRemoteAddress();
		hash_map<string,int,stringhasher>::iterator ip=ServidorSAM::ips.find(ra);

		if(ip!=ServidorSAM::ips.end())
		{
			if(ip->second>=MAX_CON_IP)
			{        	
				Send("125");
				SetCloseAndDelete();
				return;
			}
			else
				ip->second++;
        	}
		else
		{
			ServidorSAM::ips.insert(make_pair(ra,1));
		}

		list<string>::iterator r=find(ServidorSAM::baneados.begin(),ServidorSAM::baneados.end(),GetRemoteAddress());
		if(r!=ServidorSAM::baneados.end())
		{
			Send("955:Estas baneado por el administrador");
			SetCloseAndDelete();
		}else
		if(nick.length()>0)
		{	
			hash_map<string,ServidorSAM*,stringhasher>::iterator r;
			int i=0;
			string np;
			do{
				np=nick;
				if(i>0)
				{
					ostringstream o;
					o << i;
					np+=o.str();
				}
				r=ServidorSAM::clt_socket.find(np);
				i++;
			}while(r!=ServidorSAM::clt_socket.end());
			nick=np;

			string usu,a;
   			    			  
			c.nick=nick.substr(0,12);
			c.ip=GetRemoteAddress();
			par.getrest(a);
			string canal=a.substr(0,40);			    
			c.ping=false;
			c.act=0;
			ServidorSAM::clientes.push_back(c);								
			    
		        list<Canal>::iterator h;

			h=find(ServidorSAM::canales.begin(),ServidorSAM::canales.end(),canal);
 			if(h==ServidorSAM::canales.end())
			{
				 Canal canaln;
				 canaln.nombre=canal;
				 canaln.usuarios.push_back(c);
				 ServidorSAM::canales.push_back(canaln);
				 usu=";" + c.nick + ";";
				 c.canal=find(ServidorSAM::canales.begin(),ServidorSAM::canales.end(),canal);
			}
			else
			{	
				 c.canal=h;
				 h->usuarios.push_back(c);
				 list<Cliente>::iterator i1;
				 for(i1=h->usuarios.begin();i1!=h->usuarios.end();i1++)
				 {
					usu+=i1->nick + ";";
	                         	hash_map<string,ServidorSAM*,stringhasher>::iterator it=ServidorSAM::clt_socket.find(i1->nick);
                        	 	if(it!=ServidorSAM::clt_socket.end())
									it->second->Send("264:" + c.nick);
				 }
			}	
			Send("202:" + c.nick + ":" + canal + ":" + usu);		
			ServidorSAM::clt_socket.insert(make_pair(c.nick,this));			           
		}
		else
		    SetCloseAndDelete();
	}
	else
	if (a=="123")
	{
        	string tot;
	    	list<Canal>::iterator i1;
	    
            	for(i1=ServidorSAM::canales.begin();i1!=ServidorSAM::canales.end();i1++)
	    	{
			ostringstream o;
			o << i1->usuarios.size();
			tot+=";" + i1->nombre + "," + o.str() + ";";
	    	}
		Send("123:" + tot);
	}
	else
	if (a=="418")
	{	   
	    string palabra=par.getword(),a;

            if(palabra.substr(0,5)=="ADMIN")
	    {
		par.setbreak(':');		
            	a=par.getword();		
            	if(a==ServidorSAM::pass)
		{
                    Send("413");
                    c.adm=1;
            	}
		else		
		    Send("126");                 
            }else
            if(c.adm==1 && palabra.substr(0,4)=="KICK")
	    {
   		par.setbreak(':');
                a=par.getword();
                
		list<Cliente>::iterator r;

		for(r=ServidorSAM::clientes.begin();r!=ServidorSAM::clientes.end();r++)
		{
		    if(r->nick==a)
		    {	
				par.getrest(a);
				hash_map<string,ServidorSAM*,stringhasher>::iterator it=ServidorSAM::clt_socket.find(r->nick);	
		        	if(it!=ServidorSAM::clt_socket.end())
				{
					it->second->Send("271:"+ a);          	    	
				    	it->second->SetCloseAndDelete();
					ServidorSAM::baneados.push_back(r->ip);
				}
		    }else 
		    if(r->canal==c.canal)
		    {                   
                        hash_map<string,ServidorSAM*,stringhasher>::iterator it=ServidorSAM::clt_socket.find(r->nick);
                        if(it!=ServidorSAM::clt_socket.end())
				it->second->Send("276:" + a);               
		    }
          	}
	    }else
	    if(c.adm==1 && palabra.substr(0, 7)=="MENSAJE")
	    {               	
                par.setbreak(':');
		a=par.getword();
                if(a=="TODOS")
		{
          	    list<Cliente>::iterator r;
		    par.getrest(a);

	            for(r=ServidorSAM::clientes.begin();r!=ServidorSAM::clientes.end();r++)
          	    {
              		hash_map<string,ServidorSAM*,stringhasher>::iterator it=ServidorSAM::clt_socket.find(r->nick);
                        if(!(it==ServidorSAM::clt_socket.end()))
				it->second->Send("270:Administrador:" + a);
		    }              
		}else
		if(c.adm==1 && a=="HABITACION")
		{
    		    list<Cliente>::iterator r;
    		    par.getrest(a);

		    for(r=ServidorSAM::clientes.begin();r!=ServidorSAM::clientes.end();r++)
    		    {
				if(r->canal==c.canal)
				{
					hash_map<string,ServidorSAM*,stringhasher>::iterator it=ServidorSAM::clt_socket.find(r->nick);
        				if(it!=ServidorSAM::clt_socket.end())
						it->second->Send("270:Administrador:" + a);
				}
    		    }                
        	}
	    }
	}else
	if(a=="282")
	{
   	    hash_map<string,ServidorSAM*,stringhasher>::iterator m1;

	    a=par.getword();
	    m1=ServidorSAM::clt_socket.find(a);
	    if(m1!=ServidorSAM::clt_socket.end())
			m1->second->Send("439:" + a + ":");		
	}else
	if(a=="248")
	{
	    list<Canal>::iterator c1;

	    c1=c.canal;
	    if(c1!=ServidorSAM::canales.end())
	    {
		list<Cliente>::iterator u1;
		for(u1=c1->usuarios.begin();u1!=c1->usuarios.end();u1++)
		{	
			string a;
			par.getrest(a);		
			a=a.substr(0,255);
			hash_map<string,ServidorSAM*,stringhasher>::iterator m1;
			if(u1->nick!=c.nick)
			{
				m1=ServidorSAM::clt_socket.find(u1->nick);
				if(m1!=ServidorSAM::clt_socket.end())
					m1->second->Send("270:" + c.nick + ":" + a);
			}
		}
	    }
	}else
	if(a=="286")
	{	 
	    c.ping=false;	    
	}else
	if(a=="255")
	{
	    list<Canal>::iterator c1;
	    par.setbreak(':');
	    
	    c1=c.canal;
            if(c1!=ServidorSAM::canales.end())
            {		
			list<Cliente>::iterator it;
			string usr=par.getword();

			it=find(c1->usuarios.begin(),c1->usuarios.end(),usr);
			if(it!=c1->usuarios.end())
			{
				string a;
				hash_map<string,ServidorSAM*,stringhasher>::iterator m1;

				par.getrest(a);
				a=a.substr(0,255);
                		m1=ServidorSAM::clt_socket.find(it->nick);
                		if(m1!=ServidorSAM::clt_socket.end() && c.nick!=it->nick)
					m1->second->Send("256:" + c.nick + ":" + c.canal->nombre + ":" + a);			
			}
			else
				Send("281:" + usr + ":");
		}
	}else
    	if(a=="300")
    	{
			list<Cliente>::iterator it;
			hash_map<string,ServidorSAM*,stringhasher>::iterator e;
			string a;

			par.getrest(a);
			a=a.substr(0,12);	
			e=ServidorSAM::clt_socket.find(a);
			if(e==ServidorSAM::clt_socket.end())
			{	
				string viejo=c.nick;
            			list<Canal>::iterator c1;

	    			c1=c.canal;
            			if(c1!=ServidorSAM::canales.end())
            			{
                			list<Cliente>::iterator u1;
                			for(u1=c1->usuarios.begin();u1!=c1->usuarios.end();u1++)
                			{

						hash_map<string,ServidorSAM*,stringhasher>::iterator m1;
						m1=ServidorSAM::clt_socket.find(u1->nick);
						if(u1->nick==c.nick)
						{
							u1->nick=a;							
							if(m1!=ServidorSAM::clt_socket.end())
							{
								ServidorSAM::clt_socket.erase(m1);
								ServidorSAM::clt_socket.insert(make_pair(a,this));
							}								
							
							it=find(ServidorSAM::clientes.begin(),ServidorSAM::clientes.end(),c.nick);
							if(it!=ServidorSAM::clientes.end())
								it->nick=a;
							c.nick=a;
						}
						else
						{
							if(m1!=ServidorSAM::clt_socket.end())
								m1->second->Send("299:" + viejo + ":" + a);				
						}
				}						
			}
			Send("300:" + a);            
	    }
	    else
		Send("301:" + a);     
        }else
	if(a=="262")
	{
	    string a;

	    par.getrest(a);
	    a=a.substr(0,40);	    
	    if(a==c.canal->nombre)
		Send("435");
	    else
	    {
           	list<Canal>::iterator c1;

	        c1=c.canal;
                if(c1!=ServidorSAM::canales.end())
                {
               		list<Cliente>::iterator u1;
			string usu;

			for(u1=c1->usuarios.begin();u1!=c1->usuarios.end();u1++)
			{
                                if(u1->nick!=c.nick)                                
                                {
                                        hash_map<string,ServidorSAM*,stringhasher>::iterator m1;
					m1=ServidorSAM::clt_socket.find(u1->nick);
					if(m1!=ServidorSAM::clt_socket.end())
						m1->second->Send("263:" + c.nick + ":" + a);
                                }
			}			

			u1=find(c1->usuarios.begin(),c1->usuarios.end(),c.nick);
                    	c1->usuarios.erase(u1);
			if(c1->usuarios.size()==0)
			ServidorSAM::canales.erase(c1);

			u1=find(ServidorSAM::clientes.begin(),ServidorSAM::clientes.end(),c.nick);					
			c1=find(ServidorSAM::canales.begin(),ServidorSAM::canales.end(),a);
					
			if(c1==ServidorSAM::canales.end())
                    	{
                            Canal canaln;
                            canaln.nombre=a;
                            canaln.usuarios.push_back(c);
                            ServidorSAM::canales.push_back(canaln);
                            usu=";" + c.nick + ";";
			    u1->canal=find(ServidorSAM::canales.begin(),ServidorSAM::canales.end(),a);
			    c.canal=u1->canal;
                        }
                        else
                        {
                            c1->usuarios.push_back(c);
                            list<Cliente>::iterator i1;
			    usu=";";
			    for(i1=c1->usuarios.begin();i1!=c1->usuarios.end();i1++)
                                        usu+=i1->nick + ";";	
			    u1->canal=c1;
			    c.canal=c1;
                    }

		    c1=c.canal;            		                	
                    for(u1=c1->usuarios.begin();u1!=c1->usuarios.end();u1++)
                    {       
			    if(u1->nick!=c.nick)
			    {             
                        	hash_map<string,ServidorSAM*,stringhasher>::iterator m1;
                        	m1=ServidorSAM::clt_socket.find(u1->nick);
                        	if(m1!=ServidorSAM::clt_socket.end())
					m1->second->Send("264:" + c.nick);                	
			    }
            	    }
		    Send("262:" + a + ":" + usu);
                }		
	    }	    	
	}else
	    Send("954:Comando desconocido");
}

